UNIT mTKugel;

interface

uses  mSuM, mTSpielfeld, mHilfe, Math;
// Uses-Klausel ggf. anpassen

type
   TBande = record
                  Oben, Unten, Links, Rechts : Boolean;
            end;

   TKugel = CLASS
      kenntSpielfeld : TSpielfeld;
      hatStift : Stift;
      Bande : TBande;
     // Attribute
     PRIVATE

        pRadius, pGeschwindigkeit : Zahl;
     //Objektbeziehungen:
        // hatStift : Stift;

     // Methoden
     PRIVATE

        procedure SetRadius(r : Zahl);
        function GetRadius : Zahl;
        function GethPosition : Zahl;
        procedure SethPosition(x : Zahl);
        function GetvPosition : Zahl;
        procedure SetvPosition(y : Zahl);
        procedure SetGeschw(pGeschw : Zahl);
        function GetGeschw : Zahl;
        function liefereRichtung : Zahl;
        procedure SetBandenKontakt;

     PUBLIC
        constructor init(pRad, phPos, pvPos, pWinkel, pGeschw : zahl;
                         pSpielfeld : TSpielfeld);
        procedure bewege;
        procedure setzeRichtung(pWinkel: zahl);
        procedure loesche;
        procedure zeichne;
        destructor gibFrei;
        property Radius : Zahl read GetRadius write SetRadius;
        property hPosition : Zahl read GethPosition write SethPosition;
        property vPosition : Zahl read GetvPosition write SetvPosition;
        property Geschwindigkeit : Zahl read GetGeschw write SetGeschw;
        property Richtung : Zahl read liefereRichtung write setzeRichtung;
   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- SetBandenKontakt -----------------------------------------------------
procedure TKugel.SetBandenKontakt;
begin
     Bande.Oben := (vPosition - Radius <= kenntSpielfeld.Rand.Oben + 0.5);
     Bande.Unten := (vPosition + Radius >= kenntSpielfeld.Rand.Unten - 0.5);
     Bande.Links := (hPosition - Radius <= kenntSpielfeld.Rand.Links + 0.5);
     Bande.Rechts := (hPosition + Radius >= kenntSpielfeld.Rand.Rechts - 0.5);
end;
//-------- loesche -----------------------------------------------------
procedure TKugel.loesche;
begin
   hatStift.radiere;
   self.zeichne;
   hatStift.normal
end;
//-------- SetRadius ---------------------------------------------------
procedure TKugel.SetRadius(r : Zahl);
begin
     pRadius := r;
end;
//-------- GetRadius ---------------------------------------------------
function TKugel.GetRadius : Zahl;
begin
     Result := pRadius;
end;
//-------- GethPosition ------------------------------------------------
function TKugel.GethPosition : Zahl;
var Pos : Zahl;
begin
     Pos := hatStift.hPosition;

     Result := hatStift.hPosition;
end;
//-------- SethPosition ------------------------------------------------
procedure TKugel.SethPosition(x : Zahl);
begin
     hatStift.BewegeBis(x,hatStift.vPosition);
end;
//-------- GetvPosition ------------------------------------------------
function TKugel.GetvPosition : Zahl;
begin
     Result := hatStift.vPosition;
end;
//-------- SetvPosition ------------------------------------------------
procedure TKugel.SetvPosition(y : Zahl);
begin
     hatStift.BewegeBis(hatStift.hPosition,y);
end;
//-------- SetGeschw ---------------------------------------------------
procedure TKugel.SetGeschw(pGeschw : Zahl);
begin
     pGeschwindigkeit := pGeschw;
end;
//-------- GetGeschw ---------------------------------------------------
function TKugel.GetGeschw : Zahl;
begin
     Result := pGeschwindigkeit;
end;
//-------- init --------------------------------------------------------
constructor TKugel.init(pRad, phPos, pvPos, pWinkel, pGeschw : zahl;
                        pSpielfeld : TSpielfeld);
begin
     kenntSpielfeld := pSpielfeld;
     hatStift := Stift.init;
     hatStift.bewegeBis(phPos, pvPos);
     Self.zeichne;
     setzeRichtung (pWinkel);
     Geschwindigkeit := pGeschw;
     Radius := pRad;
end;

//-------- bewege ------------------------------------------------------
procedure TKugel.bewege;
begin
  with kenntSpielfeld.Rand do
     begin
          if ((hPosition >= Rechts - Radius) and  (cos(Richtung/180*Pi) > 0))
               or ((hPosition <= Links + Radius) and (cos(Richtung/180*Pi) < 0))
            then setzeRichtung (-hatStift.winkel + 180);
          if ((vPosition <= Oben + Radius) and (sin(Richtung/180*Pi) > 0))
             or ((vPosition >= Unten - Radius) and (sin(Richtung/180*Pi) < 0))
            then setzeRichtung (-hatStift.winkel);
     end;
  self.loesche;
  kenntSpielfeld.zeichne;
  hatStift.bewegeUm(0.1*Geschwindigkeit);
  Self.zeichne;
end;

//-------- setzeRichtung -----------------------------------------------
procedure TKugel.setzeRichtung(pWinkel: zahl);
begin
  hatStift.dreheBis (pWinkel)
end;
//-------- liefereRichtung -----------------------------------------------
function TKugel.liefereRichtung : Zahl;
begin
     Result := hatStift.Winkel;
end;

//-------- zeichne -----------------------------------------------------
procedure TKugel.zeichne;
begin
  hatStift.zeichneKreis(Radius);
  //hatStift.zeichneKreis(Radius-1);
end;

//-------- gibFrei -----------------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.gibFrei
end;

end.
