UNIT mTAnwendung;

interface

uses     mSuM, mUhr, mTknopf, mTRechteckschalter,
         mTKreisknopf;

 type
   TAnwendung = CLASS

     private

        derBildschirm : Bildschirm;
        dieMaus       : Maus;
        hatStift      : Buntstift;
        dieTastatur   : Tastatur;
        dieUhr        : Uhr;
        KdrehM        : TKreisknopf;
        KKette        : TKreisknopf;
        KDrehP        : TKreisknopf;
        KLang         : TKreisknopf;
        KKurz         : TKreisknopf;
        KHalt         : TRechteckschalter;
        KEnde         : TRechteckschalter;
        KErzeuge      : TRechteckschalter;
        KKugel        : TRechteckschalter;
        KLoesche      : TRechteckschalter;
        KSpiel        : TRechteckschalter;
        kWand         : TRechteckschalter;
        KAendern      : TRechteckschalter;

        zColRand      : GanzeZahl;          //Hilfsgre fr Randfarbe des
                                            //Bedienungsfeldes
        protected
        bWand         : Boolean;         // Hilfsgren fr Eigenschaft
        bKugel        : Boolean;         // 'Schalter' im Unterschied zur
        bAendern      : Boolean;         // Eigenschaft 'Taster'
        bSpiel        : Boolean;
        bHalt         : Boolean;
        zHoehe        : Integer;         //Hilfsgren fr jeweilige Bild-
        zBreite       : Integer;         //schirmeinstellung


     private

        procedure zeichneSchalttafel;

     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  zHoehe        := derBildschirm.hoehe;    //fr automatische Anpassung an die
  zBreite       := derBildschirm.breite;   //Bildschirmeinstellung
  dieMaus       := Maus.init;
  dieUhr        := Uhr.init;
  hatStift      := Buntstift.init;
  dieTastatur   := Tastatur.init;

  zeichneSchalttafel;

  //letzter Parameter bei den Schaltern und Knpfen : True  --> Schalter
  //                                                  False --> Taster
  // (nur wichtig fr die Markierung, wenn aktiviert)

  KDrehP        := TKreisknopf.init(523,zHoehe-50,'dreh+',dieMaus,False);
  KKurz         := TKreisknopf.init(470,zHoehe-50,' kurz',dieMaus,False);
  KLang         := TKreisknopf.init(416,zHoehe-50,' lang',dieMaus,False);
  KKette        := TKreisknopf.init(363,zHoehe-50,'Reihe',dieMaus,False);
  KDrehM        := TKreisknopf.init(577,zHoehe-50,'dreh-',dieMaus,False);
  KHalt         := TRechteckschalter.init(630,zHoehe-35,' Halt ',dieMaus,True);
  KEnde         := TRechteckschalter.init(715,zHoehe-55,'Ende',dieMaus,True);
  KWand         := TRechteckschalter.init(15,zHoehe-70,'Wand',dieMaus,True);
  KKugel        := TRechteckschalter.init(15,zHoehe-35,'Kugel',dieMaus,True);
  KErzeuge      := TRechteckschalter.init(215,zHoehe-70,'Erzeugen',dieMaus,False);
  KLoesche      := TRechteckschalter.init(215,zHoehe-35,'Loeschen',dieMaus,False);
  KSpiel        := TRechteckschalter.init(630,zHoehe-70,'Spiel',dieMaus,True);
  KAendern      := TRechteckschalter.init(105,zHoehe-55,'ndern',dieMaus,True);


end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
   (* Einstellen der Default-Werte *)


   bKugel     :=False;   // Ballerzeugung ausgeschaltet
   bSpiel     :=False;   // Spielstatus aus
   bAendern   :=True;    // ndern-Status ein
   bHalt      :=True;    // Spielunterbrechung an
   bWand      :=True;    // Linien knnen erzeugt werden

   kAendern.markierung(bAendern);               // Defaulwert : ndern-Modus
   kHalt.markierung(bHalt);
   kWand.markierung(bWand);

 //================= Spielschleife bis Ende-Taste angeklickt ===================

    repeat        (* Festlegung des jeweiligen Spiel-Status pro Durchgang *)
                  (* --------------  Konsole ---------------------------- *)

        If kWand.angeklickt and not bwand then
                                 begin bWand:=true;
                                       kWand.markierung(bwand);
                                       bKugel:=false ;
                                       kKugel.markierung(bKugel);
                                 end ;

        if kKugel.angeklickt and not bKugel then
                                 begin
                                       bwand:=false;
                                       kWand.markierung(bwand);
                                       bKugel:=true;
                                       kKugel.markierung(bKugel);
                                 end;

        if kAendern.angeklickt and not bAendern then
                                 begin
                                      bSpiel:=false;
                                      kSpiel.markierung(bSpiel);
                                      bAendern:=true;
                                      kAendern.markierung(bAendern);
                                      bHalt:=true;
                                      kHalt.markierung(bHalt);
                                 end;

        if kSpiel.angeklickt and not bSpiel then
                                 begin
                                      bSpiel:=True;
                                      kSpiel.markierung(bSpiel);
                                      bAendern:=False;
                                      kAendern.markierung(bAendern);
                                      bHalt:=False;
                                      kHalt.markierung(bHalt);

                                 end;

        if kHalt.angeklickt and not bHalt then
                                 begin
                                      bSpiel:=false;
                                      kSpiel.markierung(bSpiel);
                                      bAendern:=true;
                                      kAendern.markierung(bAendern);
                                      bHalt:=true;
                                      kHalt.markierung(bHalt);
                                 end;

 //-----------------------------------------------------------------------------
        (* eigentlicher Aktionsteil: nderung, Erzeugung, Lschung, Spiel *)
 //-----------------------------------------------------------------------------

 //---------------Erzeugen eines Listenelements (Linie) ------------------------

        if bAendern and kErzeuge.angeklickt and bwand Then
                     Begin

                     End;

 //---------------Lschen eines Listenelements (Linie)--------------------------

        if bAendern and kLoesche.angeklickt and bWand  Then
                     Begin

                     End;

//---------------Durchblttern der Liste (Linie)-------------------------------

        if bAendern and kKette.angeklickt  Then
                     Begin

                     end;


 //----------drehen, verlngern, krzen und frben eines Listenelements---------


        if bAendern and kLang.angeklickt Then
                     Begin
                        dieUhr.warte(50);
                     End;


        if bAendern and kKurz.angeklickt Then
                     Begin
                         dieUhr.warte(50);
                     End;


        if bAendern and bWand and kDrehP.angeklickt  Then
                     Begin
                         dieUhr.warte(200);
                     End;

        if bAendern and bWand and kDrehM.angeklickt  Then
                     Begin
                         dieUhr.warte(200);
                     End;

        if dieTastatur.wurdeGedrueckt and bWand then
                     begin
                     dieTastatur.weiter;
                     end;

   until KEnde.angeklickt;
   KEnde.markierung(true);

end;
//=================== Ende der Spiele-Schleife =================================
//==============================================================================
//-------- zeichneSchalttafel (private) --------------------------------
procedure TAnwendung.zeichneSchalttafel;
Begin
zColRand:=blau;

hatStift.hoch;
hatStift.setzeLinienBreite(3);
hatStift.bewegeBis(5,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(80,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(80,78);

hatStift.hoch;
hatStift.bewegeBis(90,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(102,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(102,78);

hatStift.hoch;
hatStift.bewegeBis(198,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(124,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(124,78);

hatStift.hoch;
hatStift.bewegeBis(330,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(280,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(280,78);

hatStift.hoch;
hatStift.bewegeBis(620,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(70,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(70,78);

hatStift.hoch;
hatStift.bewegeBis(700,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(80,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(80,78);

hatStift.setzeLinienBreite(1);
hatStift.setzeFarbe(schwarz);

End;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  dieTastatur.gibFrei;
  KAendern.gibFrei;
  KSpiel.gibFrei;
  KLoesche.gibFrei;
  KErzeuge.gibFrei;
  KKugel.gibFrei;
  KWand.gibFrei;
  KEnde.gibFrei;
  KHalt.gibFrei;
  kDrehP.gibFrei;
  KLang.gibFrei;
  KKurz.gibFrei;
  KKette.gibFrei;
  KDrehM.gibFrei;
  hatStift.gibFrei;
  dieUhr.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei ;
end;


end.
