UNIT mTAnwendung;

interface

uses     mSuM, mUhr, mTknopf, mTRechteckschalter,
         mTKreisknopf, mTLinie,  mTFigur;

 type
   TAnwendung = CLASS

     private

        derBildschirm : Bildschirm;
        dieMaus       : Maus;
        hatStift      : Buntstift;
        dieTastatur   : Tastatur;
        dieUhr        : Uhr;
        KdrehM        : TKreisknopf;
        KKette        : TKreisknopf;
        KDrehP        : TKreisknopf;
        KLang         : TKreisknopf;
        KKurz         : TKreisknopf;
        KHalt         : TRechteckschalter;
        KEnde         : TRechteckschalter;
        KErzeuge      : TRechteckschalter;
        KKugel        : TRechteckschalter;
        KLoesche      : TRechteckschalter;
        KSpiel        : TRechteckschalter;
        kWand         : TRechteckschalter;
        KAendern      : TRechteckschalter;

        aktiveFigur   : TFigur;    // fr Aktivierung via abstrakte Klasse wie
                                   // im Projekt 'Liniengraphik' (bernommen)

        aktiveLinie   : TLinie;    // Aktivierung bei verketteter Liste
        kLinie        : TLinie;
        kAnfang       : TLinie;
        kNeu          : TLinie;    // Hilfsgre
        kEnd          : TLinie;    // Ende der Liste (nur wichtig fr eventuelle
                                   // doppelte Verkettung; nicht eingebaut)

        kHilf         : TLinie;    // Hilfsgren beim Abfahren d.Listen  und
        kHelp         : TLinie;    // Lschen von Elementen  (Linien)

        zColRand      : GanzeZahl;          //Hilfsgre fr Randfarbe des
                                            //Bedienungsfeldes
        protected
        bWand         : Boolean;         // Hilfsgren fr Eigenschaft
        bKugel        : Boolean;         // 'Schalter' im Unterschied zur
        bAendern      : Boolean;         // Eigenschaft 'Taster'
        bSpiel        : Boolean;
        bHalt         : Boolean;
        zHoehe        : Integer;         //Hilfsgren fr jeweilige Bild-
        zBreite       : Integer;         //schirmeinstellung
        zLang         : Integer;         //Lnge der erzeugten Linie
        bAktivLinie   : Boolean;         //ist eine Linie aktiv ?

     private

        procedure zeichneSchalttafel;
        procedure durchdringe;           //stellt sicher, da sich Figuren beim
                                         //Durchdringen nicht lschen
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  zHoehe        := derBildschirm.hoehe;    //fr automatische Anpassung an die
  zBreite       := derBildschirm.breite;   //Bildschirmeinstellung
  dieMaus       := Maus.init;
  dieUhr        := Uhr.init;
  hatStift      := Buntstift.init;
  dieTastatur   := Tastatur.init;

  zeichneSchalttafel;

  //letzter Parameter bei den Schaltern und Knpfen : True  --> Schalter
  //                                                  False --> Taster
  // (nur wichtig fr die Markierung, wenn aktiviert)

  KDrehP        := TKreisknopf.init(523,zHoehe-50,'dreh+',dieMaus,False);
  KKurz         := TKreisknopf.init(470,zHoehe-50,' kurz',dieMaus,False);
  KLang         := TKreisknopf.init(416,zHoehe-50,' lang',dieMaus,False);
  KKette        := TKreisknopf.init(363,zHoehe-50,'Reihe',dieMaus,False);
  KDrehM        := TKreisknopf.init(577,zHoehe-50,'dreh-',dieMaus,False);
  KHalt         := TRechteckschalter.init(630,zHoehe-35,' Halt ',dieMaus,True);
  KEnde         := TRechteckschalter.init(715,zHoehe-55,'Ende',dieMaus,True);
  KWand         := TRechteckschalter.init(15,zHoehe-70,'Wand',dieMaus,True);
  KKugel        := TRechteckschalter.init(15,zHoehe-35,'Kugel',dieMaus,True);
  KErzeuge      := TRechteckschalter.init(215,zHoehe-70,'Erzeugen',dieMaus,False);
  KLoesche      := TRechteckschalter.init(215,zHoehe-35,'Loeschen',dieMaus,False);
  KSpiel        := TRechteckschalter.init(630,zHoehe-70,'Spiel',dieMaus,True);
  KAendern      := TRechteckschalter.init(105,zHoehe-55,'ndern',dieMaus,True);


end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
   (* Einstellen der Default-Werte *)

   zLang      := 85;     // Lnge der erzeugten Linien
   bKugel     :=False;   // Ballerzeugung ausgeschaltet
   bSpiel     :=False;   // Spielstatus aus
   bAendern   :=True;    // ndern-Status ein
   bHalt      :=True;    // Spielunterbrechung an
   bWand      :=True;    // Linien knnen erzeugt werden

   kAendern.markierung(bAendern);               // Defaulwert : ndern-Modus
   kHalt.markierung(bHalt);
   kWand.markierung(bWand);

   kLinie := TLinie.init(20,20,zLang,dieMaus,Nil);         // Startlinie

   kEnd:=kLinie;           // Zeiger auf Starthindernis setzen
   kAnfang:=kLinie;
   aktiveFigur:=kLinie;
   aktiveLinie:=kLinie;
   aktiveFigur.aktiviere;
   bAktivLinie:=True;

                     //Defaultwert: ein Hindernis ist aktiviert und vorhanden

 //================= Spielschleife bis Ende-Taste angeklickt ===================

    repeat        (* Festlegung des jeweiligen Spiel-Status pro Durchgang *)
                  (* --------------  Konsole ---------------------------- *)

        If kWand.angeklickt and not bwand then
                                 begin bWand:=true;
                                       kWand.markierung(bwand);
                                       bKugel:=false ;
                                       kKugel.markierung(bKugel);
                                       if not (kAnfang=nil) then
                                            begin
                                                aktiveFigur.aktiviere;
                                                bAktivLinie:=True;
                                            end;

                                  end ;

        if kKugel.angeklickt and not bKugel then
                                 begin
                                       bwand:=false;
                                       kWand.markierung(bwand);
                                       bKugel:=true;
                                       kKugel.markierung(bKugel);
                                       if not (KAnfang=nil) then
                                        begin
                                          aktiveFigur.deaktiviere;
                                          bAktivLinie:=False;
                                        end;
                                 end;

        if kAendern.angeklickt and not bAendern then
                                 begin
                                      bSpiel:=false;
                                      kSpiel.markierung(bSpiel);
                                      bAendern:=true;
                                      kAendern.markierung(bAendern);
                                      bHalt:=true;
                                      kHalt.markierung(bHalt);
                                 end;

        if kSpiel.angeklickt and not bSpiel then
                                 begin
                                      bSpiel:=True;
                                      kSpiel.markierung(bSpiel);
                                      bAendern:=False;
                                      kAendern.markierung(bAendern);
                                      bHalt:=False;
                                      kHalt.markierung(bHalt);

                                 end;

        if kHalt.angeklickt and not bHalt then
                                 begin
                                      bSpiel:=false;
                                      kSpiel.markierung(bSpiel);
                                      bAendern:=true;
                                      kAendern.markierung(bAendern);
                                      bHalt:=true;
                                      kHalt.markierung(bHalt);
                                 end;

 //-----------------------------------------------------------------------------
        (* eigentlicher Aktionsteil: nderung, Erzeugung, Lschung, Spiel *)
 //-----------------------------------------------------------------------------

 //---------------Erzeugen eines Listenelements (Linie) ------------------------

        if bAendern and kErzeuge.angeklickt and bwand Then
                     Begin
                       KNeu:=TLinie.init(215,zHoehe-100,zLang,dieMaus,KAnfang );
                                         
                       KAnfang:=KNeu;
                       if bAktivLinie then AktiveFigur.deaktiviere;
                       if not bAktivLinie then kEnd:=kAnfang;
                       aktiveFigur:=kNeu;
                       aktiveLinie:=kNeu;
                       aktiveFigur.aktiviere; bAktivLinie:=True;

   (* wichtig !!! *)   dieUhr.warte(500);        //sonst werden bei Tasten-
                                                 //druck mehrere Linien
                                                 //erzeugt, da die Repeat-
                                                 //schleife schneller ist als
                                                 //der Finger (hier 450 MHz-
                                                 //Rechner)
                     End;

 //---------------Lschen eines Listenelements (Linie)--------------------------
 //--- Einzel-Programmierung nach Listenkopf, Listenmitte, Listenende ----------
 //----  kann auch in einer einzigen Repeat-Schleife erledigt werden -----------

          if bAendern and kLoesche.angeklickt and bWand and bAktivLinie
                           and (not(kAnfang=nil)) Then
                    Begin
                      kHilf:=kAnfang;
                      kHelp:=kAnfang;
                      If aktiveLinie=kHilf
                        then
                          if aktiveLinie.vorgaenger=nil
                           then
                            begin
                            aktiveFigur.deaktiviere;   //lschen, wenn nur
                            aktiveLinie.loescheDich;   //Einzelelement existiert
                            kAnfang:=nil;  bAktivLinie:=False;
                            kEnd:=nil; aktiveLinie:=nil; aktiveFigur:=nil;
                            end
                           else
                            begin
                            aktiveFigur.deaktiviere;      //lschen, wenn aktives
                            aktiveLinie.loescheDich;      //Element gleich Listen-
                            kAnfang:=kAnfang.vorgaenger;  //kopf
                            aktiveLinie:=kAnfang;
                            aktiveFigur:=kAnfang;
                            aktiveFigur.aktiviere;
                          end

                         else
                         Begin
                         Repeat
                           khelp:=kHilf;
                           kHilf:=kHilf.vorgaenger
                         Until aktiveLinie=kHilf;

                         aktiveFigur.deaktiviere;           //lschen in Listen-
                         aktiveLinie.loescheDich;           //mitte
                         kHelp.zVorgaenger:=kHilf.vorgaenger;
                         aktiveLinie:=kHelp;
                         aktiveFigur:=aktiveLinie;
                         aktiveFigur.aktiviere;
                         if kHelp.vorgaenger=nil then kEnd:=kHelp;
                         End;

  (* wichtig !!! *)  dieUhr.warte(500);   //je nach Rechner und Mauseinstellung

                   End;

//---------------Durchblttern der Liste (Linie)-------------------------------

         if bAendern and kKette.angeklickt and bAktivLinie Then
                          Begin
                            if not(aktiveLinie.vorgaenger = nil) then
                                begin
                                   aktiveLinie:=aktiveLinie.vorgaenger;
                                   aktiveFigur.deaktiviere;
                                   aktiveFigur:=aktiveLinie;
                                   aktiveFigur.aktiviere;

            (* wichtig !! *)       dieUhr.warte(200);

                                end
                                else
                                begin
                                   aktiveLinie:=kanfang;       //Wrap around
                                   aktiveFigur.deaktiviere;    //statt Doppel-
                                   aktiveFigur:=aktiveLinie;   //verkettung
                                   aktiveFigur.aktiviere;      //Wiederanfang
                                                               //bei Listenkopf
            (* wichtig !! *)       dieUhr.warte(200);

                                end
                          end;  (*then begin *)


 //----------drehen, verlngern, krzen und frben eines Listenelements---------


         if bAendern and kLang.angeklickt and bAktivLinie Then
                                  Begin
                                    dieUhr.warte(50);
                                  End;


         if bAendern and kKurz.angeklickt and bAktivLinie Then
                                  Begin
                                    dieUhr.warte(50);
                                  End;


         if bAendern and bWand and kDrehP.angeklickt and bAktivLinie Then
                                  Begin
                                    dieUhr.warte(200);
                                  End;

         if bAendern and bWand and kDrehM.angeklickt and bAktivLinie Then
                                  Begin
                                    dieUhr.warte(200);
                                  End;

 //-----------------------------------------------------------------------------
 //----------Auswertung der Tastatur fr Bewegung der Hindernisse---------------
 //----------(Originalversion aus dem Projekt 'Liniengraphik' )-----------------
 //----------(Anpassung an Listen durch procedure durchdringe )-----------------
 //-----------------------------------------------------------------------------

     if dieTastatur.wurdeGedrueckt and bWand then
      begin
      if bAktivLinie then                            // Tastendruck auswerten
      case dieTastatur.zeichen of
        PFEILOBEN   : aktiveFigur.Bewegeum (Pfeiloben);
        PFEILUNTEN  : aktiveFigur.Bewegeum (Pfeilunten);
        PFEILRECHTS : aktiveFigur.Bewegeum (Pfeilrechts);
        PFEILLINKS  : aktiveFigur.Bewegeum (Pfeillinks);

        'r' : aktiveFigur.setzeFarbe(rot);           //Farbwahl noch aktiv wie
        's' : aktiveFigur.setzeFarbe (schwarz);      //bei Projekt Liniengraphik
        'g' : aktiveFigur.setzeFarbe (gruen);        //
        'b' : aktiveFigur.setzeFarbe (blau);         //
        { usw                                        //
           .                                         //
           .
           .
         }

      end;

      dieTastatur.weiter;

 //---------------neues Zeichnen der nicht aktivierten Listenelemente-----------
 //---------------        (Durchdringen bei Bewegung)         ------------------

      durchdringe;

    end;


 //-----------------------------------------------------------------------------
 //--------------eigentliches Spiel : die Blle fliegen ------------------------
 //-----------------------------------------------------------------------------
      (* Programmzeilen werden in den nchsten Stufen eingefgt *)



   until KEnde.angeklickt;
   KEnde.markierung(true);

end;
//=================== Ende der Spiele-Schleife =================================
//==============================================================================
//-------- zeichneSchalttafel (private) --------------------------------
procedure TAnwendung.zeichneSchalttafel;
Begin
zColRand:=blau;

hatStift.hoch;
hatStift.setzeLinienBreite(3);
hatStift.bewegeBis(5,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(80,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(80,78);

hatStift.hoch;
hatStift.bewegeBis(90,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(102,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(102,78);

hatStift.hoch;
hatStift.bewegeBis(198,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(124,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(124,78);

hatStift.hoch;
hatStift.bewegeBis(330,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(280,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(280,78);

hatStift.hoch;
hatStift.bewegeBis(620,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(70,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(70,78);

hatStift.hoch;
hatStift.bewegeBis(700,derBildschirm.hoehe-80);
hatStift.setzeFuellmuster(gefuellt);
hatStift.setzeFarbe(hellgrau);
hatStift.zeichneRechteck(80,78);
hatStift.setzeFuellmuster(durchsichtig);
hatStift.setzeFarbe(zColRand);
hatStift.zeichneRechteck(80,78);

hatStift.setzeLinienBreite(1);
hatStift.setzeFarbe(schwarz);

End;
//-------durchdringe  (private) ------------------------------------------------
procedure TAnwendung.durchdringe;
begin

 if not(kAnfang = nil)   then
       begin
       kHilf:=kAnfang;
       While (Not (kHilf.vorgaenger = Nil)) do
                    Begin
                      if (not (aktiveLinie=kHilf)) then   khilf.zeichne;
                      kHilf:=kHilf.vorgaenger;
                    End;
       kEnd.zeichne;
       aktiveLinie.zeichne; //fehlt diese Zeile, zieht die aktive Linie hinter
       end;                 //den nicht aktiven vorbei (Geschmackssache)

end;
//----------------------------------------------------------------------

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  dieTastatur.gibFrei;
  kLinie.gibFrei;
  KAendern.gibFrei;
  KSpiel.gibFrei;
  KLoesche.gibFrei;
  KErzeuge.gibFrei;
  KKugel.gibFrei;
  KWand.gibFrei;
  KEnde.gibFrei;
  KHalt.gibFrei;
  kDrehP.gibFrei;
  KLang.gibFrei;
  KKurz.gibFrei;
  KKette.gibFrei;
  KDrehM.gibFrei;
  hatStift.gibFrei;
  dieUhr.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei ;
end;


end.
