UNIT mTFigur;

interface

uses    mSuM;

type

   TFigur = CLASS

     private

     public

     protected

        derBildschirm  : Bildschirm;
        hatStift       : Buntstift;
        zFarbe         : GanzeZahl;
        zFarbeAlt      : GanzeZahl;
        zLinienstaerke : GanzeZahl;
        kenntMaus      : Maus;
        Schrittweite   : Zahl;        //Bewegen mit Pfeiltasten
        zGroesse       : Zahl;        //Linienlnge aktuell
        zxPosition     : Zahl;        //Drehpunkt der Linie
        zyPosition     : Zahl;
        zBreite        : Integer;     //automatische Bildschirmanpassung
        zHoehe         : Integer;
        zxEnd          : Zahl;        //Endpunkt der Linie , dem Drehpunkt
        zyEnd          : Zahl;        //gegenber
        zVorgaenger    : TFigur;

     private

     protected

        procedure zeichne; virtual; abstract;

     public
        
        constructor init(phPosition,pvPosition,pGroesse:GanzeZahl;pMaus:Maus;
                         pVorgaenger:tFigur);
        procedure aktiviere;
        procedure BewegeUm(pZeichen:Zeichen);
        procedure deaktiviere;
        procedure setzeFarbe(pFarbe:GanzeZahl);
        procedure setzeGroesse(pZuwachs:GanzeZahl);
        procedure loescheDich;
        function groesse : Zahl;
        function hPosition : Zahl;
        function vPosition : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TFigur: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TFigur.init(phPosition,pvPosition,pGroesse:GanzeZahl;pMaus:Maus;
                           pVorgaenger:tFigur);
                                   
begin
  zxPosition := phPosition;
  zyPosition := pvPosition;
  zGroesse := pGroesse;
  zFarbe := schwarz;
  zFarbeAlt:=zFarbe;
  hatStift := Buntstift.init;
  hatStift.bewegeBis (zxPosition, zyPosition);
  self.zeichne;
  Schrittweite := 5;
  kenntMaus := pMaus;
  zBreite:=derBildschirm.Breite;
  zHoehe:=derBildschirm.hoehe;
  zxEnd:=zxPosition+zGroesse;      //im Prinzip einzige Ergnzung zum Projekt
  zyEnd:=zyPosition;               //Liniengraphik (wird zur Drehung gebraucht)
  zVorgaenger:=pVorgaenger;        //
end;

//-------- aktiviere (public) ------------------------------------------
procedure TFigur.aktiviere;
begin
self.loescheDich;
hatStift.setzeLinienbreite(3);
zFarbeAlt:=zFarbe;
zFarbe:=hellmagenta;
self.zeichne;
end;
//-------- deaktiviere (public) ----------------------------------------
procedure TFigur.deaktiviere;
begin
 self.loescheDich;
 hatStift.setzeLinienbreite(3);
 zFarbe:=zFarbeAlt;
 //zFarbe:=schwarz;
 self.zeichne;
end;
//-------- loescheDich (private) ---------------------------------------
procedure TFigur.loescheDich;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- BewegeUm (public) -------------------------------------------
procedure TFigur.BewegeUm(pZeichen:Zeichen);

begin
  self.loescheDich;
  if pZeichen = PfeilLinks  then  if zxPosition > 5
                                  then  zxPosition := zxPosition - Schrittweite;

  if pZeichen = Pfeilrechts then  if zxPosition  < (zBreite-5)
                                  then zxPosition := zxPosition + Schrittweite;

  if pZeichen = PfeilOben   then  if zyPosition > 5
                                  then zyPosition := zyPosition - Schrittweite;

  if pZeichen = PfeilUnten  then  if (zyPosition < (zHoehe-90))
                                  then   zyPosition := zyPosition + Schrittweite;

  hatStift.bewegeBis(zxPosition, zyPosition);

  self.zeichne

end;

//-------- setzeFarbe (public) -----------------------------------------
procedure TFigur.setzeFarbe(pFarbe:GanzeZahl);
begin
  zFarbe:= pFarbe;
  zFarbeAlt:=zFarbe;
  self.zeichne;
end;

 //-------- setzeGroesse (public) ---------------------------------------
procedure TFigur.setzeGroesse(pZuwachs:GanzeZahl);
begin
  self.loescheDich;
  zGroesse := zGroesse+pZuwachs;
  self.zeichne
end;

//-------- groesse (public) --------------------------------------------
function TFigur.groesse : Zahl;
begin
  result := zGroesse
end;

//-------- hPosition (public) ------------------------------------------
function TFigur.hPosition : Zahl;
begin
  result := zxPosition
end;

//-------- vPosition (public) ------------------------------------------
function TFigur.vPosition : Zahl;
begin
  result := zyPosition
end;

//-------- gibFrei (public) --------------------------------------------
destructor TFigur.gibFrei;
begin
  hatStift.gibFrei
end;

end.
