UNIT mTFigur;

interface

uses    mSuM;

type

   TFigur = CLASS

     private

     public

     protected

        derBildschirm  : Bildschirm;
        hatStift       : Buntstift;
        zFarbe         : GanzeZahl;
        zFarbeAlt      : GanzeZahl;
        zLinienstaerke : GanzeZahl;
        kenntMaus      : Maus;
        Schrittweite   : Zahl;        //Bewegen mit Pfeiltasten
        zGroesse       : Zahl;        //Linienlnge aktuell
        zxPosition     : Zahl;        //Drehpunkt der Linie
        zyPosition     : Zahl;
        zBreite        : Integer;     //automatische Bildschirmanpassung
        zHoehe         : Integer;
        zGrad          : Integer;     //momentane Linienlage im Raum
        zxEnd          : Zahl;        //Endpunkt der Linie , dem Drehpunkt
        zyEnd          : Zahl;        //gegenber
        zVorgaenger    : TFigur;

     private

     protected

        procedure zeichne; virtual; abstract;

     public
        
        constructor init(phPosition,pvPosition,pGroesse:GanzeZahl;pMaus:Maus;
                         pVorgaenger:tFigur);
        procedure aktiviere;
        procedure BewegeUm(pZeichen:Zeichen);
        procedure deaktiviere;
        procedure setzeFarbe(pFarbe:GanzeZahl);
        procedure setzeGroesse(pZuwachs:GanzeZahl);
        procedure setzeWinkel(pWinkel:Integer);
        procedure loescheDich;
        function groesse : Zahl;
        function hPosition : Zahl;
        function vPosition : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TFigur: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TFigur.init(phPosition,pvPosition,pGroesse:GanzeZahl;pMaus:Maus;
                           pVorgaenger:tFigur);
                                   
begin
  zxPosition := phPosition;
  zyPosition := pvPosition;
  zGroesse := pGroesse;
  zFarbe := schwarz;
  zFarbeAlt:=zFarbe;
  hatStift := Buntstift.init;
  hatStift.bewegeBis (zxPosition, zyPosition);
  self.zeichne;
  Schrittweite := 5;
  kenntMaus := pMaus;
  zBreite:=derBildschirm.Breite;
  zHoehe:=derBildschirm.hoehe;
  zGrad:=0;
  zxEnd:=zxPosition+zGroesse;
  zyEnd:=zyPosition;
  zVorgaenger:=pVorgaenger;
end;

//-------- aktiviere (public) ------------------------------------------
procedure TFigur.aktiviere;
begin
self.loescheDich;
hatStift.setzeLinienbreite(3);
zFarbeAlt:=zFarbe;
zFarbe:=hellmagenta;
self.zeichne;
end;
//-------- deaktiviere (public) ----------------------------------------
procedure TFigur.deaktiviere;
begin
 self.loescheDich;
 hatStift.setzeLinienbreite(3);
 zFarbe:=zFarbeAlt;
 //zFarbe:=schwarz;
 self.zeichne;
end;
//-------- loescheDich (private) ---------------------------------------
procedure TFigur.loescheDich;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- BewegeUm (public) -------------------------------------------
procedure TFigur.BewegeUm(pZeichen:Zeichen);

Var zNGrad : Real;          //Hilfsgren
    zyyE   : Real;
begin
  self.loescheDich;
  if pZeichen = PfeilLinks  then  if zxPosition > 5
                                  then  zxPosition := zxPosition - Schrittweite;

  if pZeichen = Pfeilrechts then  if zxPosition  < (zBreite-5)
                                  then zxPosition := zxPosition + Schrittweite;

  if pZeichen = PfeilOben   then  if zyPosition > 5
                                  then zyPosition := zyPosition - Schrittweite;

  if pZeichen = PfeilUnten  then  if (zyPosition < (zHoehe-90))
                                  then   zyPosition := zyPosition + Schrittweite;

//ist die Linie nach unten gerichtet und kann beim Verschieben die Konsole ber-
//schrieben werden?  zGrad kann negativ oder positiv sein, je nachdem wie bisher
//gedreht wurde. Wichtig fr den Schutz der Konsole ist nur der Fall, da der
//Drehpunkt oben liegt und zGrad einen Winkel im 3. oder 4. Quadranten markiert.

If ((zGrad > 180) and (zGrad < 360)) or ((zgrad < 0) and (zGrad > -180))
then
begin
  ZNGrad:=zGrad;  //Drehzustand der Linie retten
  If zGrad < 0 then zNGrad:=360-abs(zGrad);
  If (zNGrad > 180) and (zNGrad < 270) then zNGrad:=270-zNGrad;
  If (zNGrad >=270) and (zNGrad < 360) then zNGrad:=zNGrad-270;

  zNGrad:=zNGrad*3.14159/180;
  zyyE:=zGroesse*cos(zNGrad)+zyPosition ;

end
else
   zyyE:=zyPosition;

//----------------------------------------------------------------------------

 IF not (Round(zyyE) < (zHoehe-90))
  then
    zyPosition := zyPosition - Schrittweite;  //rckgngig machen, da fr
                                              //Konsole offenbar gefhrlich

  hatStift.bewegeBis(zxPosition, zyPosition);

  self.zeichne

end;

//-------- setzeFarbe (public) -----------------------------------------
procedure TFigur.setzeFarbe(pFarbe:GanzeZahl);
begin
  zFarbe:= pFarbe;
  zFarbeAlt:=zFarbe;
  self.zeichne;
end;

 //-------- setzeGroesse (public) ---------------------------------------
procedure TFigur.setzeGroesse(pZuwachs:GanzeZahl);
Var zNGrad : Real;           //Hilfsgren
    zyyE   :Real;
begin
  self.loescheDich;
  zGroesse := zGroesse+pZuwachs;

//ist die Linie nach unten gerichtet und kann beim Verschieben die Konsole ber-
//schrieben werden?  zGrad kann negativ oder positiv sein, je nachdem wie bisher
//gedreht wurde. Wichtig fr den Schutz der Konsole ist nur der Fall, da der
//Drehpunkt oben liegt und zGrad einen Winkel im 3. oder 4. Quadranten markiert.

If ((zGrad > 180) and (zGrad <360)) or ((zgrad < 0) and (zGrad > -180))
then
begin
  ZNGrad:=zGrad;                                //Drehzustand der Linie retten
  If zGrad < 0 then zNGrad:=360-abs(zGrad);
  If (zNGrad > 180) and (zNGrad < 270) then zNGrad:=270-zNGrad;
  If (zNGrad >=270) and (zNGrad < 360) then zNGrad:=zNGrad-270;

  zNGrad:=zNGrad*3.14159/180;
  zyyE:=Round(zGroesse*cos(zNGrad))+zyPosition;
end
else
   zyyE:=zyPosition;

  if (zGroesse > zBreite-20) or (zGroesse < 10)
  then zGroesse:=zGroesse-pZuwachs;

  IF not (Round(zyyE) < (zHoehe-90))
  then zGroesse:=zGroesse-pZuwachs;   //Verlngerung rckgngig machen, da sonst
                                      //Konsole berschrieben wird

  self.zeichne
end;

//-------- setzeWinkel (public) ---------------------------------------
procedure TFigur.setzeWinkel(pWinkel:Integer);
Var z1 : Real;
    z2 : Real;    //reine Hilfsgren, damit die Terme berschaubar bleiben
    z3 : Real;

begin
  self.loescheDich;
  zGrad := zGrad+pWinkel;

  If zGrad >=0 Then zGrad:=zGrad mod 360
              else zGrad:=zGrad mod(-360);
  z1:=zHoehe-90-zyPosition;      // Abstand des Drehpunkts von der Konsole

  If Round(z1) < (zGroesse) then
  begin
  z2:=z1/zGroesse;               //cos des nicht erlaubten Winkels
  z3:=sqrt(1.0-sqr(z2))/z2;      //tan .............
  z3:=arctan(z3);                //Winkel im Bogenma
  z3:=z3/3.14159*180;            //Winkel im Gradma
  If zGrad >=0 Then
             begin
              if (zGrad <(270-z3)) or (zGrad >= (270 +z3))
              then hatStift.dreheUm(pWinkel)
              else zGrad:=zGrad-pWinkel           //es wird nur so weit gedreht,
             end;                                 //da die Konsole nicht ber-
  if zGrad < 0 then                               //schrieben wird
             begin
              if (zGrad <(-90-z3)) or (zGrad >= (-90+z3))
              then hatStift.dreheUm(pWinkel)
              else zGrad:=zGrad-pWinkel
             end;
  end
  else hatStift.dreheUm(pWinkel);
  self.zeichne;

end;

//-------- groesse (public) --------------------------------------------
function TFigur.groesse : Zahl;
begin
  result := zGroesse
end;

//-------- hPosition (public) ------------------------------------------
function TFigur.hPosition : Zahl;
begin
  result := zxPosition
end;

//-------- vPosition (public) ------------------------------------------
function TFigur.vPosition : Zahl;
begin
  result := zyPosition
end;

//-------- gibFrei (public) --------------------------------------------
destructor TFigur.gibFrei;
begin
  hatStift.gibFrei
end;

end.
