program Ball_und_Wand_6;

(* Ideen zu einem greren Abschluprojekt, das die Projekte Billardspiel,
   Liniengraphik, Tastaturknpfe und Zug+Waggons voraussetzt und zusammenfat.
   Eventuell knnte dies, in der einen oder anderen Form, auch Grundlage fr
   eine Facharbeit sein.

                  =================================
                        Blle und Hindernisse
                  =================================

   Ausgehend von dem Billard-Projekt soll eine Spielkonsole mit Tasten program-
   miert werden, die es gestattet, ein Spielfeld nur durch Mausklick zu erzeugen
   und zu steuern. Die Wnde (bzw. Hindernisse im Innern des Spielfeldes) werden
   in verketteten Listen verwaltet und knnen frei auf dem Bildschirm positio-
   niert, gedreht, vergrert, verkleinert, erzeugt und gelscht werden.
   Die Blle im Spiel werden ebenfalls in einer verketteten Liste verwaltet.
   Sie knnen ( auch whrend des Spiels) erzeugt, positioniert und gelscht
   werden. Ein Spiel-Stopp ist jederzeit fr nderungen mglich.     *)

               (*Stufe 1 --> Programmierung der Schalter und Taster der Steuer-
                             konsole. *)

               (*Stufe 2 --> Erzeugen und Lschen von Hindernissen, die zu-
                             nchst nur horizontale Linien sind. Die Elemente
                             sind in verketteten Listen gespeichert, die per
                             Mausklick durchsucht werden knnen. *)

               (*Stufe_3 --> Die Taster fr das Verlngern der Hindernisse
                             und das Drehen in beliebige Richtungen werden
                             programmiert. Die Figuren knnen sich beim
                             Positionieren durchdringen ( ohne sich zu zer-
                             stren ). Das Bedienfeld ist geschtzt, so da beim
                             Drehen, Verlngern und Positionieren kein ber-
                             malen mglich ist.
                             Am Ende dieser Projekt-Stufe 3 kann ein Hindernis-
                             feld beliebig erstellt und variiert werden. *)

               (*Stufe_4 --> In der Projekt-Stufe 4 werden die Blle analog zu
                             den Hindernissen programmiert. Sie knnen erzeugt
                             und gelscht werden. Blle und Hindernisse bilden
                             je eine verkettete Liste. Auch die Blle knnen
                             nach dem Erzeugen im Spiel positioniert werden.
                             Zwischen Hindernis-Liste und Ball-Liste kann be-
                             liebig gewechselt werden. 

               (*Stufe_5 --> Die Spiel-Schleife der Run-Routine von mTAnwendung
                             wird programmiert. Zunchst werden nur Auenwnde
                             bei der Reflexion von Bllen bercksichtigt. Wnde
                             im Innenbereich des Spielfeldes reflektieren zwar
                             die Blle, sie werden aber im Verlauf des Spieles
                             von den Bllen berschrieben, da die Reflexion an
                             freien Enden von Wnden im Programm noch nicht
                             bercksichtigt wurde.  *)

               (*Stufe_6 --> Innenwnde als Hindernisse mit freien Enden werden
                             programmiert. D.h., Hindernisse knnen auch Striche
                             im Innern des Spielefeldes sein. Hindernisse knnen
                             also auf beiden Seiten und an ihren Enden bei be-
                             liebiger Lage im Raum reagieren.Das Spiel ist nun
                             fertig bis auf das gegenseitige Durchdringen von
                             Bllen. *)

                             (* nderungen im Vergleich zu Stufe_5:
                                mTAnwendung: bRand definiert, bRand in Spiel-
                                             schleife eingebaut, bRand in
                                             fliegeAnders an mTFigur bergeben
                                mTFigur    : bRande definiert, Funct. Randge-
                                             troffen definiert, procedure
                                             fliegeAnders stark verndert
                                mTLinie    : bRand definiert, Funct. getroffen
                                             stark erweitert, Funct. RandGetrof-
                                             fen definiert    *)

               (*Stufe_7 --> Auch Blle stoen aneinander und werden an sich
                             reflektiert. Alle Dummy-Routinen sind vorhanden.
                             Diese Stufe wurde (noch) nicht realisiert. *)


(* Bekannte Unzulnglichkeiten des Spiels ( Faulheit des Programmierers ):

   Die Auenwnde knnen beliebige spitze Winkel bzw. 90-Grad-Winkel ein-
   schlieen. Der Algorithmus funktioniert bis ca. 110 Grad. Grund: Wrden
   alle stumpfen Winkel zugelassen, mte man zwischen freien Innenhindernissen
   und Auenwnden unterscheiden und knnte sie nicht mehr in einer Unterklasse
   behandeln (Problem der Reflexion von Bllen an freien Enden von Linien).
   Blle und Wnde benutzen die in der Liniengraphik erstellten Klassen
   mTFigur (abstrakt), mTKreis und mTLinie. Bei einigen Problemen des Spiels
   zeigte sich das Ableiten von einer abstrakten Klasse eher als Hemmschuh.
   Daher wurde das ursprngliche Vorhaben, Blle und Linien in einer einzigen
   verketteten Liste zu vereinigen, verworfen ( eigentlichen unterscheiden sich
   Blle und Hindernisse ja nur dadurch, da die einen die Masse 'Unendlich'
   bezglich des Impulssatzes haben).

   Bei der Programmierung der groen Spiele-Schleife in der Run-Routine von
   mTAnwendung wurde nicht (!) elegant programmiert, etwa durch Zusammenfassung
   von hnlichen Ablufen in Prozeduren. Es soll klarwerden, wie die Einzel-
   schritte ineinandergreifen.

   Bei der Berechnung von Reflexionen an Wnden mit beliebiger Lage und Innen-
   hindernissen wurde die Unit 'MATH' aus Delphi eingebunden. Einziger Grund:
   Normalerweise steht nur der ArcTan zur Verfgung. Dadurch kann es bei Be-
   rechnungen von 90-Grad-Winkeln zu Microsoft-eigenen blauen Bildschirmen kom-
   men, wenn man nicht spitzfindige Sicherungen einbaut. 'MATH' stellt den
   ArcCos zur Verfgung, bei dem es keine solchen Schwierigkeiten gibt. Der
   ArcCos aus 'MATH' ist von 0 bis 2 Pi definiert und damit hier sehr geeignet.

//------------------------------------------------------------------------------
// Projekt 'Ballspiel mit Hindernissen' : Die Schalter und Tasten
//------------------------------------------------------------------------------
// Schalter 'Wand' und Schalter 'Kugel' :
// WippSchalter, die entweder Wnde oder Kugeln fr Erzeugung, Lschung und
// Vernderung zulassen.

// Schalter 'ndern' und Schalter 'Spiel' :
// Wippschalter, die entweder den nderungs- oder Spielmodus bestimmen.
// Der Schalter 'Halt' ist an 'ndern' gekoppelt und hat gleiche Funktionen.

// Taster 'Erzeugen' und Taster 'Lschen' :
// Wnde und Blle knnen erzeugt oder vernichtet werden. Voraus-
// setzung: es liegt der ndern-Modus vor. Wird ein Spiel durch 'Halt' unter-
// brochen, mu man die Schalter 'Wand' und 'Kugel' einmal im Wechsel bettigen,
// um die Listen wieder zu initialisieren.

// Taster 'Reihe'  :
// Wenn eine Liste von Objekten existiert, kann im ndern-Modus
// diese Liste abgefahren werden. Das markierte Element wird andersfarbig ge-
// zeichnet (siehe Projekt Liniengraphik). Das jeweils markierte Element
// kann per Taste 'Lschen' aus der Liste entfernt werden.

// Pfeiltasten :
// Das jeweils markierte Element kann im 'ndern-Modus'auf dem Bildschirm
// beliebig positioniert werden.

// Tasten 'lang', 'kurz', 'dreh+' und 'dreh-' :
// Diese Taster fr die Gestaltung der Hindernisse wurden in Stufe 3
// programmiert. 'Farbe' kann noch ber die Tasten g,s,b,r eingestellt werden
// (Relikt aus dem Projekt 'Liniengraphik'). Die Blle knnen z.Z. noch nicht
// vergrert oder verkleinert werden (wenige zu ergnzende Programmzeilen).
*)

uses
  mSum,
  mTKnopf in 'mTKnopf.pas',
  mTKreisknopf in 'mTKreisknopf.pas',
  mTRechteckschalter in 'mTRechteckschalter.pas',
  mTAnwendung in 'mTAnwendung.pas',
  mTLinie in 'mTLinie.pas', //Klasse aus dem Projekt 'Liniengraphik' 
  mTFigur in 'mTFigur.pas', //die abstrakte Oberklasse aus 'Liniengraphik'
  mTBall in 'mTBall.pas';   //das alte mTKreis des Projekts 'Liniengraphik'

var
  Anwendung : TAnwendung;

begin
  // Initialisierung
  Anwendung := TAnwendung.init;

  // Aktionsteil
  Anwendung.run;

  // Aufrumen
  Anwendung.GibFrei
  end.

