UNIT mTLinie;

interface

uses          mSuM, mTFigur, math;   //'math' nur wegen ArcCos

type
   TLinie = CLASS(TFigur)

     private

     bRand: Boolean;
     Abst : zahl;

     public

       zVorgaenger  : TLinie;

     public

        procedure zeichne; override;
        function zGrade : Zahl;override;
        function getroffen(pRad:Integer;pVelo,pxK,pyK :Zahl) : boolean; override;
        function vorgaenger : TLinie;
        function RandGetroffen : Boolean; override;
        function pruefsumme : Zahl; override;
        constructor init(phPosition,pvPosition,pGroesse:GanzeZahl;pMaus:Maus;
                         pvorgaenger:TLinie;pVelo,pVeloWinkel:Real);

   end;

implementation

//+---------------------------------------------------------------------
//|         TLinie: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (public) --------------------------------------------
procedure TLinie.zeichne;
begin
  hatStift.setzeFarbe(zFarbe);
  hatStift.runter;
  hatStift.bewegeUm (zGroesse);

  zxEnd:=hatStift.hPosition;
  zyEnd:=hatStift.vPosition;

  hatStift.dreheUm(180);
  hatStift.hoch;
  hatStift.bewegeUm(zGroesse);
  hatStift.dreheUm(180);
end;
//-------- init --------------------------------------------------------
constructor TLinie.init(phPosition,pvPosition,pGroesse:GanzeZahl;pMaus:Maus;
                          pVorgaenger:TLinie;pVelo,pVeloWinkel:Real);

Begin
inherited init(phPosition,pvPosition,pGroesse,pMaus,pVorgaenger,
            pVelo,pVeloWinkel);
zVorgaenger:=pvorgaenger;         //mu von mTAnwendung aus beim Lschen in der
End;                              //Linien-Liste verbogen werden

//-------- getroffen (public) ------------------------------------------
function TLinie.getroffen(pRad:Integer;pVelo,pxK,pyK:Zahl) : boolean;
Var
    e : Zahl;             //Abstnde des Balls von den Endpunkten
    f : Zahl;             //
    cosiGamma : Zahl; 
    cosiBeta  : Zahl;
    gamma     : Zahl;     //Winkel im Dreieck aus e, f und der Linie 
    beta      : Zahl;     //
    bTest     : Boolean;

begin

    f:=sqrt(sqr(zxPosition-pxK)+sqr(zyPosition-pyK));
    e:=sqrt(sqr(zxEnd-pxK)+sqr(zyEnd-pyK));
    cosiGamma:=(sqr(f)+sqr(zGroesse)-sqr(e))/(2*f*zGroesse);  //Kosinussatz
    cosiBeta:=(sqr(e)+sqr(zGroesse)-sqr(f))/(2*e*zGroesse);

    beta:=arccos(cosibeta);
    gamma:=arccos(cosigamma);
    beta:=180/3.14159*beta;
    gamma:=180/3.14159*gamma;

    abst:=f*sin(gamma/180*3.14159);

    bRand:=false;
    bTest:=false;

       if (((Beta >= 0)and (beta<=110)) and ((Gamma >=0) and (gamma<=110)))
                  and (round(abst) < (pVelo+pRad+5))   //dieser Wert sollte
            then  bTest:=true                          //etwas kleiner
            else                                       //als der untere Wert
               begin                                   //sein;der Algorithmus
                 if min(e,f) < (pVelo+pRad+6)  //--->  //ist ziemlich grob;
                     then                              //
                       begin
                         bRand:=true;
                         btest:=true;
                       end ;

               end  ;

   result:=bTest;

end;

//-------vorgaenger (public) --------------------------------------------
 function TLinie.vorgaenger : TLinie;
begin
  result := zVorgaenger
end;

//-------RandGetroffen (public) ------------------------------------------------
 function TLinie.RandGetroffen : Boolean;
begin
  result := bRand;
end;

//-------- pruefsumme (public) -------------------------------------------------
function TLinie.pruefsumme : Zahl;
begin
  result:=zxPosition+zyPosition+zyEnd+zxEnd+zGroesse+zGrad;
end;

//-------- zGrade (public) -----------------------------------------------------
function Tlinie.zGrade : Zahl;
begin
   result := 360-zGrad;
end;


end.
