UNIT mTRechteckschalter;

interface

uses    mSum, mTKnopf;

type
   TRechteckschalter = CLASS(TKnopf)


     private
        zLang : Real;     //Hilfsvariable fr Textlnge auf Knopf
        zMark :Boolean;   //Taster oder Schalter, Markierung unterschiedlich

     private

        procedure zeichne; override;

     public

        function angeklickt : boolean; override;
        procedure markierung(pMark:Boolean); override ;

   end;

implementation

//+---------------------------------------------------------------------
//|         TRechteckschalter: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (private) -------------------------------------------
procedure TRechteckschalter.zeichne;
begin
  hatStift.hoch;
  hatStift.bewegeBis (zKnopfx,zKnopfy);
  hatStift.runter;
  hatStift.setzeLinienBreite(2);
  hatStift.setzeSchriftGroesse(22);
  hatStift.setzeSchriftstil(1);
  zLang:=hatStift.Textbreite(zText);
  hatStift.zeichneRechteck(zLang+10,22+4);
  hatStift.setzeFuellmuster(gefuellt);
  hatStift.setzeFarbe(gelb);
  hatStift.bewegeBis (zKnopfx+2,zKnopfy+2);
  hatStift.zeichneRechteck(zLang+10-4,22+4-4);
  hatStift.setzeFarbe(schwarz);
  hatStift.hoch;
  hatStift.bewegeBis(zKnopfx+5,zKnopfy+2);
  hatStift.schreibeText(zText);
  hatStift.bewegeBis (zKnopfx,zKnopfy);
  hatStift.setzeFuellmuster(durchsichtig);
  hatStift.zeichneRechteck(zLang+10,22+4);
end;

//-------- angeklickt (public) -----------------------------------------
function TRechteckschalter.angeklickt : boolean;
begin
  result := kenntMaus.istGedrueckt 
  AND (kenntMaus.hposition >= zKnopfx)
  AND (kenntMaus.hposition <= zKnopfx+zLang+10)
  AND (kenntMaus.vposition >= zKnopfy)
  AND (kenntMaus.vposition <= zKnopfy+22+4);
  if not zArt then Begin
                    if result  then hatStift.setzeFarbe(rot)
                    else hatStift.setzeFarbe(weiss);
                    hatStift.setzeFuellMuster(durchsichtig);
                    hatStift.hoch;
                    hatStift.bewegeBis(zKnopfx-2,zKnopfy-2);
                    hatStift.zeichneRechteck(zLang+10+4,22+4+4);
                    hatStift.setzeFarbe(schwarz);
                   end;
end;
//-------- markierung (public) -----------------------------------------
procedure TRechteckschalter.markierung(pMark:Boolean);
begin
zMark:=pMark;
 if zMark then hatStift.setzeFarbe(rot) else hatStift.setzeFarbe(weiss);
    hatStift.setzeFuellMuster(durchsichtig);
    hatStift.hoch;
    hatStift.bewegeBis(zKnopfx-2,zKnopfy-2);
    hatStift.zeichneRechteck(zLang+10+4,22+4+4);
    hatStift.setzeFarbe(schwarz);
 end;
end.
